﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

public class ButtonSounds : MonoBehaviour, IPointerEnterHandler, ISelectHandler{

    public AudioClip selectedSound, selectionSound;

    private Button button { get { return GetComponent<Button>(); } }
    private AudioSource source { get { return GetComponent<AudioSource>(); } }
    //private AudioController audioController; 

    // Use this for initialization
    void Start()
    {
        //audioController = GameObject.FindGameObjectWithTag("AudioController").GetComponent<AudioController>();
        gameObject.AddComponent<AudioSource>();
        source.clip = selectedSound;
        source.playOnAwake = false;
        button.onClick.AddListener(() => PlaySelectedSound());
    }

    private void Update()
    {
        if (AudioController.isFXActive())
            button.onClick.AddListener(() => PlaySelectedSound());
        else
            button.onClick.AddListener(null);
    }

    void PlaySelectedSound()
    {
        if (AudioController.isFXActive())
            source.PlayOneShot(selectedSound);
    }

    public void PlaySelectionSound()
    {
        if (AudioController.isFXActive())
            source.PlayOneShot(selectionSound);
    }

    public void OnPointerEnter(PointerEventData eventData)
    {
        if (AudioController.isFXActive())
            PlaySelectionSound();
    }

    public void OnSelect(BaseEventData eventData)
    {
        if (AudioController.isFXActive())
            PlaySelectionSound();
    }
}
