﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent (typeof (Animator))]
[RequireComponent(typeof(AudioSource))]
[RequireComponent(typeof(SpriteRenderer))]
[RequireComponent(typeof(Collider2D))]
public class CheckpointItem : MonoBehaviour
{
    private Animator anim;
    private AudioSource audio;
    private SpriteRenderer render;

    // Use this for initialization
    void Start ()
    {
        anim = GetComponent<Animator>();
        audio = GetComponent<AudioSource>();
        render = GetComponent <SpriteRenderer>();
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.gameObject.CompareTag("Player") && !anim.GetBool("Checked"))
        {
            CheckpointManager.SaveLastCheckpoint();     //Savepoint
            anim.SetBool("Checked", true);
            if(AudioController.isFXActive())
            {
                audio.Play();
            }
            render.color = Color.green;
        }
    }
}
