﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PickupItem : MonoBehaviour
{
    private AudioSource audioSource;
    private bool triggered;

    // Use this for initialization
    void Start()
    {
        audioSource = GetComponent<AudioSource>();
        triggered = false;
    }

    void OnCollisionEnter2D(Collision2D other)
    {
        if (other.gameObject.CompareTag("Player") && !triggered)
        {
            gameObject.GetComponent<Collider2D>().enabled = false;
            triggered = true;
            if(AudioController.isFXActive())
                audioSource.Play();

            //Put the crystal in the UI counting
            if (this.gameObject.CompareTag("Crystal"))
            {
                ScoreManager.newCrystal();
                gameObject.GetComponent<Renderer>().enabled = false;
                Destroy(this.gameObject, 2);
            }
            else if (this.gameObject.CompareTag("Boost"))
            {
                GoblinControllerScript gc = other.gameObject.GetComponent<GoblinControllerScript>();
                StartCoroutine(gc.AddBoost());
                gameObject.GetComponent<Renderer>().enabled = false;
                Destroy(this.gameObject, gc.boostSeconds+1);
            }

        }
    }
}