﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[System.Serializable]
public class CheckpointManager : MonoBehaviour {
    
    static GameObject[] enemiesInScene;
    static GameObject player;

    // Use this for initialization
    void Awake () {
        CheckObjects();
    }
    private void Start()
    {
        SaveLastCheckpoint();
    }

    static void CheckObjects()
    {
        player = GameObject.FindGameObjectWithTag("Player");
        enemiesInScene = GameObject.FindGameObjectsWithTag("Enemy");
    }

    public static void RestoreToLastCheckpoint()
    {
        CheckObjects();
        if (enemiesInScene!=null)
        {
            foreach (GameObject enemy in enemiesInScene)
            {
                if (!enemy.GetComponent<DamageableItem>().isDead)
                {
                    enemy.GetComponent<EnemyBehaviour>().RestoreLastCheckpointPos();
                    enemy.GetComponent<DamageableItem>().RestoreLastHealth();
                }
            }
        }
        player.GetComponent<GoblinControllerScript>().RestoreLastCheckpointPos();
        player.GetComponent<DamageableItem>().RestoreLastHealth();
    }
    
    public static void SaveLastCheckpoint()
    {
        CheckObjects();
        if (enemiesInScene != null)
        {
            foreach (GameObject enemy in enemiesInScene)
            {
                if (!enemy.GetComponent<DamageableItem>().isDead)
                {
                    enemy.GetComponent<EnemyBehaviour>().SaveLastCheckpointPos();
                    enemy.GetComponent<DamageableItem>().SaveLastHealth();
                }
            }
        }
        player.GetComponent<GoblinControllerScript>().SaveLastCheckpointPos();
        player.GetComponent<DamageableItem>().SaveLastHealth();
    }
}
