﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ScoreManager : MonoBehaviour {

    [SerializeField]
    public Text countingCrystalsText;

    [SerializeField]
    public Text countingPointsText;

    static private ScoreManager instance;
    static private int cCrystals, cPoints;

    private void Awake()
    {
        // Singleton enforcement
        if (instance == null)
        {
            // Register as singleton if first
            instance = this;
            DontDestroyOnLoad(this);
        }
        else
        {
            // Self-destruct if another instance exists
            Destroy(this);
            return;
        }
    }

    // Use this for initialization
    private void Start () {
        cCrystals = PlayerPrefs.GetInt("Cristals");
        cPoints = PlayerPrefs.GetInt("Points");
	}

    // Update is called once per frame
    private void Update () {
        updateStats();

    }

    public void updateStats()
    {
        if (!countingCrystalsText.text.Equals(cCrystals.ToString()))
        {
            countingCrystalsText.text = cCrystals.ToString();
            PlayerPrefs.SetInt("Cristals", cCrystals);
        }
        if (!countingPointsText.text.Equals(cPoints.ToString()))
        {
            countingPointsText.text = cPoints.ToString();
            PlayerPrefs.SetInt("Points", cPoints);
        }

    }

    public static void newCrystal()
    {
        cCrystals++;
    }

    public static void newPoint(int amount)
    {
        cPoints += amount;
    }

    public static void resetPoints()
    {
        cPoints = 0;
    }

    public static int getcCrystals()
    {
        return cCrystals;
    }

    public static void UsecCrystals(int amount)
    {
        if(cCrystals>amount)
            cCrystals -= amount;
    }

    public static int getcPoints()
    {
        return cPoints;
    }

    public static void UsecPoints(int amount)
    {
        if (cPoints > amount)
        {
            cPoints -= amount;
            cCrystals += 1;
        }
    }
}
