﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BGParallax : MonoBehaviour {

    public Transform[] backgrounds;

    private float[] parallaxProportions;
    public float parallaxAmount = 1f;

    private Transform cam;
    private Vector3 previousCamPos;


    // Use this for initialization
    void Start () {
        cam = Camera.main.transform;
        previousCamPos = cam.position;

        parallaxProportions = new float[backgrounds.Length];

        // asigning
        for (int x = 0;  x < backgrounds.Length;  x++)
        {
            parallaxProportions[x] = backgrounds[x].position.z * -1;
        }
    }
	
	void FixedUpdate () {

		for (int x = 0; x< backgrounds.Length; x++)
        {
            //opposite of the current position of the camera movement
            float parallax = (previousCamPos.x - cam.position.x) * parallaxProportions[x];
            //targetx = current position + parallax
            float backgroundTargetPosX = backgrounds[x].position.x + parallax;
            //target = backgroundCurPos with target's x position
            Vector3 backgroundTargetPos = new Vector3(backgroundTargetPosX, backgrounds[x].position.y, backgrounds[x].position.z);
            //fade between current and target pos
            backgrounds[x].position = Vector3.Lerp(backgrounds[x].position, backgroundTargetPos, parallaxAmount * Time.deltaTime);
        }

        //Set prevCamPos to camPos at the end of the frame
        previousCamPos = cam.position;
	}

}
