﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FloatingTextController : MonoBehaviour {

    private static FloatingDamageText popupTextPrefab;
    private static GameObject canvas;

    public static void Initialize()
    {
        if(!popupTextPrefab)
            popupTextPrefab = Resources.Load<FloatingDamageText>("Prefabs/UI/PopupTextParent");
        canvas = GameObject.Find("GeneralCanvas");
    }

    public static void CreateFloatingText(string text, Transform location, Color col)
    {
        FloatingDamageText instance = Instantiate(popupTextPrefab);
        instance.SetText(text, col);
        Vector2 screenPos = Camera.main.WorldToScreenPoint(new Vector2(location.position.x + Random.Range(-.1f,.1f), location.position.y + Random.Range(-.1f, .1f)));
        instance.transform.SetParent(canvas.transform, false);
        instance.transform.position = screenPos;
    }

}
