﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Scroller : MonoBehaviour {

    public float backgroundSize;

    private Transform[] layers;
    private Transform cam;
    private float viewZone = 10;
    private int leftIndex;
    private int rightIndex;

    // Use this for initialization
    void Start () {

        cam = Camera.main.transform;
       
        layers = new Transform[transform.childCount];
        for(int i = 0; i < transform.childCount; i++)
        {
            layers[i] = transform.GetChild(i);
        }
        leftIndex = 0;
        rightIndex = layers.Length - 1;
    }
	
	// Update is called once per frame
	void Update () {
        //Scrolling
        if (cam.position.x < (layers[leftIndex].transform.position.x ))
            ScrollLeft();

        if (cam.position.x > (layers[rightIndex].transform.position.x - viewZone))
            ScrollRight();
    }
    
    private void ScrollLeft()
    {
        layers[rightIndex].position = Vector3.left * (layers[leftIndex].position.x - backgroundSize);
        leftIndex = rightIndex;
        rightIndex--;
        if (rightIndex < 0)
        {
            rightIndex = layers.Length - 1;
        }
    }

    private void ScrollRight()
    {
        layers[leftIndex].position = Vector3.right * (layers[rightIndex].position.x + backgroundSize);
        rightIndex = leftIndex;
        leftIndex++;
        if (leftIndex == layers.Length - 1)
        {
            leftIndex = 0;
        }
    }

}
