﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent (typeof(DamageableItem))]
[RequireComponent (typeof(FlashingItem))]
public class Invulnerability : MonoBehaviour {

    static DamageableItem dmgAbleItem;
    FlashingItem flashItem;
    public float secondsToWaitUntilDmgAgain = 3;
    static Invulnerability instance;

    void Awake()
    {
        instance = this;
    }

    // Use this for initialization
    void Start () {
        dmgAbleItem = GetComponent<DamageableItem>();
        flashItem = GetComponent<FlashingItem>();
        if(PlayerPrefs.GetFloat("invulSeconds")>secondsToWaitUntilDmgAgain)
        {
            secondsToWaitUntilDmgAgain = PlayerPrefs.GetFloat("invulSeconds");
        }
        else
        {
            PlayerPrefs.SetFloat("invulSeconds", secondsToWaitUntilDmgAgain);
        }
    }

    public static void TriggerInvulnerability()
    {
        if (!dmgAbleItem.Invulnerability)
        {
            if(dmgAbleItem.damageTaken)
                instance.StartCoroutine(instance.TempInvulnerability(dmgAbleItem.damageTaken));
            else
                instance.StartCoroutine(instance.TempInvulnerability(false));
        }
    }

    public IEnumerator TempInvulnerability(bool damageTaken)
    {
        dmgAbleItem.Invulnerability = true; //flaging the invulnerability
        flashItem.TriggerFlash = true;
        if (damageTaken)
        {
            yield return new WaitForSeconds(3);
        }
        else
        {
            yield return new WaitForSeconds(secondsToWaitUntilDmgAgain);
        }
        flashItem.TriggerFlash = false;
        flashItem.stopFlashing();
        dmgAbleItem.Invulnerability = false; //unflaging the invulnerability
        damageTaken = false;
    }
}
